Help Contents

Search and Replace Regular Expression Wizard Help Contents

The Search and Replace Regular Expression Wizard is used to help you create, understand, and debug Regular Expressions used by our Search and Replace utility version 6.1 and above. The wizard allows you to construct new expressions, or modify existing ones, using a term-by-term approach. You can visualize the effect of each term in a sample text that you can paste into the program from the clipboard or retrieve from a file on disk. The effect of specific terms is presented in-context, using colors to distinguish the current term from other parts of the overall expression. 'Search' and 'Replace' Expressions are constructed/ examined in separate screens of the Wizard so you can work on each part semi-independent of the other. You can move back & forth between the Wizard screens to make adjustments or experiment. The sample text can also be changed at any point by returning to the starting screen. When you are satisfied, the final expressions can be inserted automatically in the respective fields in the Search and Replace main program dialog (if Search and Replace is running).

See Tips for more information on program usage.

If you do not have Search and Replace, a shareware copy can be obtained from our web site at www.funduc.com.

You may wish to view the help topic on Search and Replace Regular Expressions.

Click here or on the forward arrow above to continue...


SR Regular Expression Wizard Sample Text Screen

SR Regular Expression Wizard - Sample Text

Scroll your screen for text or click on the graphic for help. Also see Tips for suggestions on complex expressions. See Search Expression for the next Wizard screen.

Search Expression: When the Regular Expression Wizard first opens this field will contain the current search expression in the Search and Replace main dialog (if the program is running) or the last expressions in effect when the Wizard was used. The expression here will be the initial expression in the used Search Expression section of the Wizard. You may accept this or type/paste-in another. Blank out the expression if you want to start from scratch. See Tips for more information.

Replace Expression: When the Regular Expression Wizard first opens this field will contain the current search expression in the Search and Replace main dialog (if the program is running) or the last expressions in effect when the Wizard was used. The expression here will be the initial expression in the used Replace Expression section of the Wizard in the You may accept this expression or type/paste in another. Blank out the expression if you want to start from scratch. See Tips for more information.

Case Sensitive: Check/Uncheck this for case sensitive search or not.

Sample Text: The sample text to use to help you visualize the effect of the search and replace expressions. You can use the "Load from file" button to retrieve sample text from a file or the "Paste" button to insert text currently in the Windows clipboard.

Next Button: Click here to move to the next step.


Search Expressions Screen

Scroll your screen for text or click on the graphic for help. Also see Tips for suggestions on complex expressions. See Replacement Expression for the next Wizard screen.

Sample Text: The sample text you supplied in the Sample section of the Wizard is presented here. The display colors can be used to visualize the effect of each operator on the first search hit. Blue identifies the operator currently highlighted in the "Expression" section of the dialog. Red identifies sections of the sample that are effected in some way by other operators in the "Expression" section. If the text is all dark, your search expression has not identified any hits.

Note that coloring is only available for the first overall search hit. Only one search hit is possible in the sample text here. If two (or more) were possible, coloring would be applied to the first hit only. You have an opportunity in the Evaluation section of the Wizard to examine each hit individually.

Search Expression List: The individual component subexpressions (operators) of the "Search Expression" from the Sample section of the Wizard are listed here. Click on each subexpression to see the controls associated with that subexpression - you can modify them (click on Apply to save your change). To add a new subexpression, use the Add or Insert button. Use the Move Up, Move Down, & Remove buttons to rearrange or delete subexpressions.

Code Column: This column lists the '%n values' for the regular expression operators. Regular expression wild card search operators are represented by %n operators (%1, %2, etc) in the counterpart replacement expression. The entries in the 'Code' column are there as an aid so you can visualize in the sample text know in advance what the %n number will for the operator in the replacement expression. The %n operators are selected via 'Match of search expression #1, Match of search expression #2, etc' in the 'Expression Type' field of the Replace Expression window.

Search Expression Type: This combo box provides a list of the Wizard's build in operators. The choices are:

Exactly one occurrence: Select this to enter a literal string. Type the string itself in the "of String" field below. Note that if you enter and of the regular expression 'reserved characters' they will be converted to literals.

Zero or more occurrences: This is the Search and Replace * operator. If you want to establish a specific set of characters to enter in a () term, type them into the "of String" field. If you want to use [ ] and a range, highlight a range of characters in the 'of characters' list by holding down Shift as you select with the mouse or cursor keys. Click Apply or Insert to effect the entry.
NOTE: If you want to enter *[], select Zero or more occurrences, highlight all the characters in the 'of characters' list and click Apply or Insert.

One or more occurrences: This is the Search and Replace + operator. Usage is similar to the above.

A given range or occurrences: This is the Search and Replace 'Column Operator'. You can create a new entry using steps similar to the above or you can apply column operator to an existing entry by clicking on apply.

Beginning of Line: This is the Search and Replace ^ operator.

End of Line: This is the Search and Replace $ operator.

Start of file: This is the Search and Replace ^^ operator.

End of file: This is the Search and Replace $$ operator.

Expression below *not* matched: This is the Search and Replace 'not' operator - !. You will need to create a not expression in sections.

Expression below *is* matched: Use this to create ! operator terms that function as a type of 'and' operator.

Search Occurrences: Entered here in the ''At least' and '... but no more than' fields are the number of columns to match. This area is only available for input when 'A given range or occurrences' is selected in the Expression Type field. See 'Column Operator' for more information.

Of String Field: Enter a literal string to use here. You can combine this with one of the operators in the "Expression Type" field. Note: Regular expression reserved characters will be made into literals with a \ character.

Or Characters List: This is a list of binary characters & standard alphanumeric characters you can use with one of the Expression Type choices. To select multiple characters, hold the shift key as you scroll or hold the ctrl key and select single items. When you press Insert or Apply, the selected items will be used.
Note: When Regular Expression mode is turned on in Search and Replace it is not necessary to use the binary mode dialogs. Binary codes can be inserted directly into the Search and Replace 'search' and 'replace' fields. The Regular Expression Wizard is always in 'regular expression' mode.

Apply Button: Apply the changes to the highlighted item.

Remove Button: Remove the highlighted item from the Expression list.

Move Up Button: Move the highlighted item up by one in the Expression list.

Move Down Button: Move the highlighted item down by one in the Expression list.

Add Button: Add the highlighted item to the bottom of the Expression list.

Insert Button: Insert the current item one below the currently highlighted item in the Expression list.


Replacement Expressions Screen

Scroll your screen for text or click on the graphic for help. Also see Tips for suggestions on complex expressions. See Evaluation Screen for the next Wizard screen

Sample Text: The sample text you supplied in the Sample section of the Wizard is presented here. The display colors can be used to visualize the effect of each replacement operator on the first search hit. Blue identifies the operator currently highlighted in the "Expression" section of the dialog. Red identifies sections of the sample that are effected in some way by other operators in the "Expression" section. If the text is all dark, your search expression has not identified any hits.

Replacement Expression List: Initially listed here are the individual component subexpresions of the "Replace Expression" from the Sample section of the Wizard. Click on each subexpression to see the controls associated with that subexpression - you can modify them (click on Apply to save your change). To add a new subexpression, use the Add or Insert button. Use the Move Up, Move Down, & Remove buttons to rearrange or delete subexpressions.

Expression Type: This list contains counterparts to the search expression operators and a choice to enter a specific string - "String Listed Below" - in which you would specify a string in the "String" field.
Note: If your literal string involves any of the 'reserved characters', be sure to put a \ character in front of each to denote the literal.

String Field: Enter a literal string to use here. Input here is meant to be combined with the ''String Listed Below' choice in the Expression Type field. If your literal string involves any of the 'reserved characters', be sure to put a \ character in front of each to denote the literal.

Case Switch: Check or uncheck to change the case during a replace. This only affects a regular expression replacement operator.

Apply Button: Apply the changes to the highlighted item.

Remove Button: Remove the highlighted item from the Expression list.

Move Up Button: Move the highlighted item up by one in the Expression list.

Move Down Button: Move the highlighted item down by one in the Expression list.

Add Button: Add the highlighted item to the bottom of the Expression list.

Insert Button: Insert the current item one below the currently highlighted item in the Expression list.


Expression Evaluation Screen

Scroll your screen for text or click on the graphic for help. See Replacement Expression for the previous Wizard screen.

Sample Text: This is the original sample based on the current Search expression.

Evaluator Replacement Sample: This is the replaced text based on the current Replace expression.

Evaluator Previous Hit: Jump back to the previous search hit (if any) in the sample text.

Previous/Next Hit Buttons: Jump back/forward to the previous/next search hit (if any) in the sample text.

Finish Button: Closes the wizard. If Search and Replace is running the search and replace strings will be inserted into the respective fields in Search and Replace before the exiting. If Search and Replace is not running, the fields will be saved for the next time you run the program.


Wizard Usage Tips

The Search and Replace Regular Expression Wizard allows you to build expressions from scratch using a term-by-term approach. We intend for the program to be most useful as a learning and debugging tool. Uncomplicated expressions can be easily accomplished with the Wizard. However, complex expressions that involve many operators may present some difficulties if you are trying to construct them from scratch. In fact, advanced users who are already familiar with Search and Replace's syntax will likely prefer to use the Wizard as tool for debugging and fine tuning their expressions.

If you find that the Search Expression or Replace Expression components of the Wizard are not cooperating with your intentions, consider returning to the Sample Text screen and making manual adjustments to your code in the 'Search Expression' and 'Replace Expression' fields. Then return to the screen you were working on and double check your progress. You can repeatedly return to the Sample Text screen if necessary - the fields and values in the other screens will be refreshed whenever content of the 'Search Expression' and 'Replace Expression' fields is changed.

Known Limitations

  • Search and Replace can have very long strings in the 'Search for' and 'Replace with' fields. However, entries longer than 255 characters will not import fully into the Wizard upon startup. For very long terms you will need to copy & paste them from Search and Replace into the Wizard.

  • The 'Expression below not matched' and 'Expression below is matched' selections may behave erratically when constructing ! expressions from scratch. Return to the Sample Text screen to make manual adjustments.

  • Advanced users may find that the Search Expression builder will try to make literals too often. For example, if you specify a - character to make a range of characters in [ ], the program will turn that into \-. You can instead mark blocks of characters in the 'Or Characters List' or return to the Sample Text screen and make manually adjustments to your terms.


Installation Instructions

The Search and Replace Regular Expression Wizard is a standalone application that can be installed in any path on your hard disk. If you use our self-installer, the program can be uninstalled via Control Panel -> Add/Remove Programs or Programs and Features (Vista). If you install via a zip package, see instructions in the zip for uninstall info.

If you do not have Search and Replace, a shareware copy can be obtained from our web site at www.funduc.com.


Operating System Compatibility

Search and Replace Regular Expression Wizard runs on Windows 2000, XP (Pro & Home), 2003, and Vista (all versions).

Notes:

  • Windows 95/98/ME users: These platforms are no longer officially supported. At minimum you will need a fully patched version of your operating system per what was available at the end of the respective product life cycle.

  • Windows NT users: We recommend you install Service Pac 6.


About Box

Search and Replace Regular Expression Wizard About Box

This window contains system and copyright information. The underlined link to our web site will launch the default www browser for your computer and take you to http://www.funduc.com. The underlined EMail link will launch the default Internet EMail program for your computer. Click the Ordering Info button for Ordering Information or the License Info button for License Information.

For customer support, please contact us via Email at support@funduc.com.


License Information

Search and Replace Regular Expression Wizard License Information

Search and Replace Regular Expression Wizard
Copyright (c) 1999-2009 by Funduc Software Inc.
www.funduc.com www.searchandreplace.com
support@funduc.com support@searchandreplace.com
All rights reserved.

License Agreement and Warranty Disclaimer

You should carefully read the following terms and conditions before using this software. Use of this software indicates your acceptance of these terms and conditions. If you do not agree with them, do not use the software.

Freeware Version

You are hereby licensed to: use the Freeware Version of Search and Replace Regular Expression Wizard for as long as you want; Make as many copies of the Freeware version of this software as you wish; Give exact copies of the original Freeware version to anyone; Distribute the Freeware version of the software in its unmodified form via electronic means. There is no charge for any of the above.

You are specifically prohibited from charging, or requesting donations, for any such copies, however made; and from distributing the software and/or documentation with other products (commercial or otherwise) without prior written permission.

The Search and Replace Regular Expression Wizard documentation is not freeware. You are specifically prohibited from distributing in any form the program documentation file(s):, "Srrxwiz.chm" or "SRX.chm" or "SR.chm".

Evaluation and Registration

If you wish to purchase a licensed registration of the Search and Replace Regular Expression Wizard and obtain the documentation, see Ordering Information).

Customer support can be obtained by visiting our homepage at http://ww.funduc.com. or by E-MAIL (support@funduc.com).

Registered Version License

One registered copy of the Search and Replace Regular Expression Wizard documentation may be dedicated to a single person who uses the software on one or more computers or workstations that are for their own exclusive use and for which they are the sole user.

Licensing is not based on "concurrent" users. If multiple workstations are to access the program in any form and for any length of time you must purchase licenses for the number of users that will access the program. If you make the registered version of the Search and Replace Regular Expression Wizard documentation available through a network and accessible by multiple users or workstations you are required to purchase licenses for the software covering all workstations that will access the software through the network. Special pricing is available for multiple licenses. See Ordering Information for information on how to purchase (register).

Customer support can be obtained by visiting our homepage at http://www.funduc.com or by E-MAIL (support@funduc.com)

Governing Law

This agreement shall be governed by the laws of the State of Michigan, United States of Amercia

Disclaimer of Warranty

This software and the accompanying files are sold "as is" and without warranties as to performance of merchantability or any other warranties whether expressed or implied. In particular, there is no warranty for the string Replacing feature.

Good data processing procedure dictates that any program be thoroughly tested with non-critical data before relying on it. The user must assume the entire risk of using the program. Any liability of the seller will be limited exclusively to product replacement or refund of purchase price.


Ordering Information

Purchasing SR Regular Expression Wizard Help

The Search and Replace Regular Expression Wizard program is freeware. The program help file available for a base price of $10/ user. If you are a registered Search and Replace user you will also receive an extension on your Search and Replace support/update period when you purchase the program help for Search and Replace Regular Expression Wizard.

Email delivery is free. If you want a diskette mailed, add $5 for US postal delivery or $8 for International mail.

Quantity discounts are listed in the fax/mail order form and on our WWW site, www.funduc.com.

Registration includes free program updates and customer support (by Email) for six months. Updates are sent to registered customers quarterly. They incorporate your suggestions, so please send them! If you have problems receiving the program or need customer support, contact us by Email at support@funduc.com.

Credit Card Registration:

  • Secure Internet Transaction: If you have a secure Web browser such as Netscape or Internet Explorer, you may register by credit card via a secure Web transaction from our web site at: http://www.funduc.com.

  • Fax Registration: To register using a credit card via fax, open and print the fax/mail order form. You may also edit and print the file, 'Order.txt', in the program subdirectory. Please write clearly or type when you complete the form. Please check our web site - www.funduc.com/contact.htm - for the fax number to use. Fax orders are processed within a few hours during the USA business day. Allow 7-10 days for postal deliveries. Write support@funduc.com if you have a question about your order.

  • Phone Registration: Call the number indicated on the page at www.funduc.com/contact.htm to order using a credit card. Please specify that the order is for Search and Replace. Phone orders with email delivery are typically processed within one business day. Allow 7-10 days for postal deliveries. Write support@funduc.com if you have a question about your order.

PayPal Money Transfer: Please write support@funduc.com for instructions about registration via PayPal "Send Money" funds transfer. We will provide you instructions via email reply. Thanks.

Check Registration: Open and print the fax/mail order form. You may also edit and print the file, 'Order.txt', in the program subdirectory. Please write clearly or type when you complete the form. Mail the form and a check to the address indicated on the form. Please allow 7-10 days for check order processing and then contact support@funduc.com if you did not receive the program. Payments must be in US dollars drawn on a US bank or international postal money order in US dollars. If you send a postal money order, do so only by some form of registered mail that can be traced!


Funduc Software Products

Please visit our Web site at http://www.funduc.com for more information, freeware, shareware, and purchases of these and other products.

Search & Replace

Search and Replace is our award winning utility loved by programmers, webmasters, and novice computer users alike. If you need to find and replace text, or just find text, this utility is a must have.

Search and Replace looks through multiple files for a string and can also replace it with another string. It can search subdirectories and ZIP files and do case sensitive or insensitive searches. Extensive support for regular expression (egrep) search & replacement includes operations that span more than one line, insertion of the path & filename during replacements, and incrementing number replacements. Binary search & replace mode can be combined with regular expressions. Precise control over replacements is available through multiple confirmation options and a built-in context viewer that allows you to view replacements in- context, before they are made. An HTML Mode can be used to make html special character code substitutions during search/replace. Ignore Whitespace mode makes it convenient to handle spaces & cr-lf during non-regular expression operations. A built-in script editor makes frequent &/or complex multi-step search/replace operations easy to prepare. Advanced script operations include a boolean expression evaluator that provides additional control over which files are processed by the script. Advanced scripts also allow you to specify the program options in effect, insert comments in scripts, and perform iterative script operations. Multiple file masks and file date & size filters can be used to include &/or exclude files during regular and scripted operations. The internal context viewer includes a build-in editor for editing text files. The full complement of command line switches (including script launching) is ideal for network managers & advanced users. Other functions include: "Touch" files (change time/date stamp & file attributes); Preservation of original file date during replacements; Replacements on backup path files instead of the originals; Output reports to monitor operations; Shell extensions to launch Search & Replace from Explorer and the Find Menu; and more. A detailed help file with examples are included. Several foreign language interface are available from ttp://www.funduc.com.

Search and Replace has received several awards from WUGNET® (Windows User Group Net) Windows NT Shareware Pick of the Week (www.wugnet.com/shareware), Windows Magazine (www.winmag.com) Superior Shareware, and has been featured several times in Lockergnome's Free Windows 95/NT E-zine (www.lockergnome.com). It has a ZDNet Hotfiles (www.hotfiles.com) of 5 stars, & a TUCOWS (www.tucows.com) 5 Cow rating.

Search and Replace Regular Expression Wizard

Search and Replace Regular Expression Wizard is a step-by-step wizard to help you build regular expressions for use in Search and Replace. The expressions can be constructed from a menu of operators having English language counterparts. The impact of the operators is displayed in color coded form on a sample text you provide. You can move back & forth between search operators - replace operators - final results to adjust your expressions as necessary. When finished, the final expressions are inserted into the corresponding Search and Replace fields if Search and Replace is running. The Wizard itself is freeware. Documentation requires a one time purchase.

Directory Toolkit

Directory Toolkit is a multipurpose directory comparison and file manager that provides features missing from Windows. It displays single directory lists or side- by-side directory comparisons using color coding for alike, different, or missing files. Comparisons can be based on dates or a binary file analysis of file content. You can copy, move, & rename files while retaining long filenames and six built-in synchronize functions simplify updating directories. Built-in archive functions, with Explorer shell extensions, let you create & manage archives from Explorer and use Directory Toolkit as your primary archive manager for supported archives (zip, tar, gz, lz (read only), & cab). File operations and directory comparison functions work seamlessly on files in archives, e.g., no need to manually extract files first. Other features include statistics for file counts and path sizes; Ignoring filename case during comparisons; Explorer compatible OLE drag n Drop; Split/Concatenate files to/from diskettes; Encode/Decode UENCODE, Base64(Mime), BinHex(Mac), XXENCODE and yEnc formats, (Decode also includes quoted-printable, 7 bit unencoded, & plain text); An integrated comparison viewer for a color coded display of the actual differences in files; Safe physical sort of directories; Touch files (change time/date & attributes stamps); Find duplicate files on a drive; Open files and launch applications; Multiple include/exclude file masks and the ability to include/exclude files based on size and date; Command line switches & script functions to automate comparisons & synchronize operations & control program options in effect via batch files; Configurable output file and print functions to create reports of single and comparison directory lists; Detects & runs (optionally) setup programs in archives; Display file version information including 8.3 file name equivalents; File numbering to number files sequentially based on adjustable sort order and a user defined starting value. Help file with examples included. International versions are available from http://www.funduc.com.

Directory Toolkit has been a winner of the WUGNET® Windows NT Shareware Pick of the Week for (www.wugnet.com/shareware), WUGNET® Windows95 Best Choice Shareware for the week, and featured Lockergnome's Free Windows 95/NT E-zine (www.lockergnome.com). It has a ZDNet Hotfiles (www.hotfiles.com) of 5 stars.

Funduc Software ZIP Extractor

Funduc Software ZIP Extractor is ZIP "self-extractor stub" that lets you turn your ZIP files into a self-extracting executable that will automatically unZIP the archive when launched. This allows you to share your zip files with another person who might not have an unzip software on their computer &/or who might have only occasional use for an unzip tool. The self-extractor allows some or all files to be extracted and can create the paths in the zip file (default) or "flatten" the directory structure (unzip into a single path).

Registry Toolkit

Registry Toolkit lets you search &/or replace and edit the Windows registry. You can specify the data types to process, start key, case sensitive, whole word. Regular expression operations using an egrep-type syntax are also available. You can create/edit keys, values, &/or data manually if you wish. A unique 'operations' function lets you move/copy/delete/export values you select. For example, you can copy/move keys from one location in the registry to another. The program now maintains multiple 'undo' files that can be used to reverse previous changes (10 is the default). An automatic 'last change' undo is available from the program GUI. Replaces can be previewed in advance, in-context. Replaces can also be previewed in the context of an overall search - a comparison dialog then lets you select/deselect specific operations to perform before making the overall replace. The program can print search & registry browse results. The .reg import function allows you to compare existing data vs. data to be imported - specific items can then be selected/deselected. The .reg export function can be used to make special .reg files that delete keys when merged via Registry Toolkit or our new Registry Toolkit Merge program (see our web site). The various program comparison dialogs are configurable and their contents can be copied to the windows clipboard. The program can read DOS environment variables and use them in a search/replace. Script file & command line functions are available for automated &/or complex operations. Registry Toolkit will operate on a remote registry (if you have permission to do so). A German interface is available.

Registry Toolkit Merge

Registry Toolkit Merge is a companion program for Registry Toolkit. Registry Toolkit Merge is a command line that merges .reg files into the Windows registry. Registry Toolkit Merge is unique because it can be used to create self-contained, self-importing .exe's. When clicked on, the .reg information is imported into the registry (after confirmation). This is be useful, for example, if you need to distribute a .reg file to others but are worried that they might not know how to import a .reg file manually. Alternatively, a .reg file can be passed to the program from the command line. Like Registry Toolkit, the program can be used to apply .reg files that will delete keys from the registry or copy/move them to another location -- tasks that cannot be accomplished easily by the regedit.exe .reg merge function that comes with Windows.

Folder Synchronize

Folder Synchronize is a command-line utility useful to network administrators and other power users. It provides a subset of the functions in our Directory Toolkit utility, namely, the comparison & synchronize functions. We created Folder Synchronize for those who needed those functions but not the GUI interface & other functions of Directory Toolkit such as archive management, file operations, etc. Folder Synchronize is a native 32-bit executable for use with all 32 bit Windows platforms.

Folder Synchronize can synchronize two paths using one of 6 synch methods. The program can also do a comparison-only. This is useful with the output report function. When the output report is enabled it will contain a summary of the path comparison &/or a summary of the file operations carried out by the synchronize. Other features include: Switchable display (or not) of a progress meter; A custom bitmap & message of your choice can be displayed on the screen while an operation progresses; A 'No Cancel' switch can be used to make it less easy for a procedure to be interrupted; Require (or not) confirmation of file operations; Complex include/exclude file masks that let you include/exclude some file or subdirectories while including others; Multiple operations can be submitted to the program via multiple 'configuration files'.

Folder Synchronize Script Editor

The 'Script Editor' is used to generate (or edit) script files that can then be used with Folder Synchronize or our Directory Toolkit utility. The script switches are presented in an organized arrangement. The display of related switches can be collapsed/expanded for readability.

Application Mover

Application Mover is a tool that relocates installed programs from one path to another on your hard disk. Application Mover takes files found one path and moves them to another that you specify. Application Mover scans the windows registry for references to old file location and adjust the registry to the new location. Application Mover also scans all windows shortcuts in the Start Menu and adjusts those as well. *.ini and *.log files present in the program's path are updated to reflect the new location of your program.

Application Inventory

Application Inventory is a utility that scans your system for program .exe files and generates a configurable report about the files that were located. Optional follow-up scans are then initiated to cross-reference the initial scan results with windows .lnk shortcuts and/or references in the windows registry. Further details on files are available from Properties and References dialogs. Include and exclude filters are available to define the initial search by path &/or string(s) found in file version information. The fields included in the initial file scan are configurable. Results be sorted, copied to the clipboard, printed, or saved in a delimited file you specify. Application Inventory can also launch windows explorer on the path containing a file in the results list. Although Application Inventory is intended as a reporting tool, various windows properties sheets can be launched that allow you to make edits to file or shortcut properties. The program defaults to scanning for .exe files but a special switch is available to scan for another file type that you specify.

Duplicate File Finder

Duplicate File Finder is utility for 32 bit windows that locates duplicate files on in one or more paths. Unlike other utilities that only check file names, Duplicate File Finder performs a binary comparison of file contents and can locate files that are alike regardless of names. The path(s) to scan is configurable by file path and file mask(s) and filter settings can be used to include/exclude files by date, size, attribute. Results can be saved to a tab delimited file. Supplementary functions include launching files, deleting files to the recycle bin, opening Explorer on a path, and examining file properties.

File Merge Express

File Merge Express is a file comparison and merge utility for 32 bit Windows. The program displays a contents comparison of two files and can (optionally) create a third file, 'Merge File' that consists of the merge of the two files being compared. The Merge File can (optionally) be opened in the built-in text (or binary) editor. The program has options for file naming of the Merge File, including automatic naming when the two source files for the comparison have the same name. The Compare Files dialog is also used to establish parameters such line prefixes, colors, orientation of the preview, etc. Command line parameters are available to specify files to compare or a script file to use. The program can also be launched from the Windows Explorer right click menu. File Merge Express will also supplement our Directory Toolkit utility. If both programs are installed, Directory Toolkit's file contents comparison will automatically employ File Merge Express, which has more features than Directory Toolkit's internal routine.

Delivery Agent

Delivery Agent is a send-only e-mail program, with mail merge functions, for use by web site managers, network administrators, customer relations and support personnel, etc. The program is used to deliver frequently used, customer-requested e-mail messages (& MIME attachments) such as newsletters, product delivery & announcements, support notes, etc. Messages can be sent to one or more users by selecting a message from a list and entering the users' address. The program can read a text file containing a list of addresses for bulk delivery. Recipients of bulk deliveries are shielded from seeing the other recipients in the list. The program checks a POP e-mail account prior to sending message via SMTP - useful for servers that 'validate' the users current IP address prior to mail relays. Version 3.0 adds MAPI support. When activated, the program will route outgoing messages to your primary MAPI-aware e-mail program. Mail merge field name definitions, variable names, and data are stored in a single file containing the data and e-mail addresses. Variable names can be anything you like (except for the name of the e-mail address field). Mail Merge 'Constants' can also be defined. The program has a customizable header function that can be used to send web mail' or 'HTML mail'. The "To: " field can also be customized for bulk, non- mail merge deliveries. Port settings to use and maximum number of recipients per block can be configured manually. Settings and messages can be created via the program GUI or, once you are familiar with the program, via an external text editor. A full complement of command line switches allows the program to be incorporated into your .bat routines. A log file of deliveries can be enabled (or not).

Shortcut Doctor

Shortcut Doctor allows you to check your Windows links/shortcuts and see which contain targets which can no longer be found. The program can then delete the shortcuts, resolve them, or carry out search/replace operations to modify shortcut fields with or without validation of new paths. Network Drive mappings can be inserted in the Replace dialog automatically. Individual shortcuts can be edited and all shortcuts on a drive can be displayed, regardless of whether they are valid or not. Explorer Internet URLS can also be checked for problems. CD-ROM drives, network drives, and specific paths can be ignored during processing. Includes an Empty Recent Documents button. Script files, run from the command line, allow you to do multiple operations, control program options, and easily specify complex paths. A German interface is available.

Funduc Explorer Extensions

Explorer Extensions is a collection of enhancements for the Windows Explorer right-click context menu: a) Encode and Decode Email attachments - support for UUENCODE, Base64(Mime), BinHex(Mac), XXENCODE, quoted-printable, 7 bit unencoded, & plain text, b) Split and Concatenate large files into smaller ones for storage on floppies & visa versa. Split can be based on file size or a string found in a file, c) Touch files - change the time, date, & attributes of files. Touch can add (or subtract) a user specified time value from the current file time. d) File Operations - copy/move/rename/delete files using complex file masks. The program can also change the case of file names & number files. A German version is available.

Drive Bar

Drive Bar allows you to conveniently open views of your drives in the Windows Explorer. Drive Bar's Auto Hide function allows it to disappear from view when not in use so that it does not take up screen space. Drive Bar is resizable and can be set to remain visible at all times. It can also be set to launch alternative file manager programs in lieu of Windows Explorer, launch views as "Tiled" or not, ignore specified drives in the list of drive icons, and run automatically at Windows startup.

Update Toolkit

Update Toolkit is a multi-purpose application intended for administrators network managers. This program was created for those who need some or all of the separate functions of our Folder Synchronize, Shortcut Doctor, Registry Toolkit, and Search and Replace utilities under one command line application. Operations are controlled by scripts and are highly configurable. While Update Toolkit can be used on individual machines, it is oriented toward 'logon-script' operations for workstations. The program has no user interface and therefore is well suited for automated operations.

Count Characters (freeware)

Count Characters copies most Windows controls' data to the clipboard! That's just one of the features of this freeware program from Funduc Software. The program can report the type and content of some of the windows currently displayed on your desktop and for the most popular types of controls (including lists and trees) it can copy their contents to the clipboard. You can also copy the contents of password fields and regular text boxes. Cost: Free.

Decode Shell Extension (freeware)

Decode Shell Extension is very popular freeware app is an extension for the Windows Explorer. The program allows you to decode Internet email attachments by right-clicking on a saved message file from Explorer and selecting Decode from the menu. The program supports multiple attachments, multi-part files (already concatenated), UUENCODED, Base64(MIME), BinHex (Mac format), quoted-printable, XXENCODED, plain text files, and User (table) encoded files. If the attachment contains only one file, Decode Shell Extension will offer to open it using either the associated program or Notepad. For virus safety reasons, it will not offer to launch .exe., .com, .bat, & .cmd files. You should scan decoded Word and Excel files with your anti-virus checker before loading them.

DBComp Ver 1.0 (freeware)

DBComp is a database comparison and merge application that compare two OBDC data sources for alike vs. different records and generate a "Difference File" that lists the records that either do not match or have been added/deleted from one data source compared to the other. DBComp can also perform a "Merge" operation that uses Difference File generated by DBComp and updates an OBDC data source via SQL statements. You can view the SQL statements in advance and remove one (or more) in advance if you wish. DBComp version 1.0 is freeware.

Word Search and Replace

Word Search and Replace is a freeware macro for Microsoft Word. It uses the 'find and replace' functions of MS Word to perform a search/replace in one or more files selected by a file mask supplied by the user. We created 'WordSR' for those who need to search/replace in Word documents only. The macro can use the Word 'Pattern Matching' regular expression switch. Case Sensitive and Whole Word search/replace is also possible

Excel Search and Replace

Excel Search and Replace is a counterpart to our Word Search and Replace. This is a freeware macro for Microsoft Excel that searches (and replaces) in multiple .xls files using Excel's built-in find & replace function.

PowerPoint Search and Replace

PowerPoint Search and Replace rounds out our collection of freeware find and replace Office Macros. This macro is a PowerPoint .ppt file that works with MS PowerPoint files using the find and replace functions that are part of PowerPoint. You need to have the full version of PowerPoint installed. The macro can be run as a slide show but it will not work if you only have the PowerPoint Show Viewer from Microsoft.

TZAdjust (freeware)

TZAdjust, which stands for Time Zone Adjust, is a freeware app we created for users who find it necessary to make manual changes to the Windows time zone and 'day light savings' offset parameters. TZAdjust is probably of greatest interest to Windows NT-class users. NT/2000/XP returns time information as an offset from Greenwich Mean Time (GMT). In addition, the OS automatically makes Daylight Savings compensations when reporting file times. One can disable "Automatically Adjust for Daylight Savings" entirely in the Windows Day/Time Properties dialog but there may be other instances where finer control over time zone and the daylight offset is desired. Do not use TZAdjust casually. Be sure to read the information in the 'readme.txt' before using this program.

FSHED (freeware)

FSHED, which stands for Funduc Software Hex Editor, is a freeware hex editor whose functions include File Insert; File Revert; Bookmarking; Clipboard Paste choices; Block Selection; Search/Replace; Read only switch; Print Preview; Display Choices (Bytes per line, Offset length, ANSI/OEM, Little-Endian/Big-Endian, Font Size, Screen Colors, & more). Search and Replace can be configured to use FSHED instead of HexView.

HexView for Windows (freeware)

HexView is a multiple document Hexadecimal viewer that can display, print, and print preview any file as a hex dump. It is intended as a supplement for Search and Replace for Windows, however, it is a standalone app and does not require Search and Replace. A Japanese version is available.

Limit Edit (freeware)

Limit Edit expands upon the built-in limit feature for edit boxes & rich edit controls by letting you set your own maximum size settings for the amount of text permitted in edit boxes and rich edit controls. For example, Limit Edit can set a limit on the amount of text allowed in an instance of the Notepad text editor. The Limit Edit dialog also displays interesting information about the types of controls in use by a program. Although intended for edit boxes and rich edit controls only, it may also work on some other controls that are subclasses of these. Separate 16 and 32 bit version included.

INI to Registry (freeware)

INI to Registry works well with any program that relies on .ini files. It can read the contents of any INI file and load them into the Windows registry. That way programs which previously used INI files can read the old data from the registry. The program is free. The source code is available for $25. Please E-MAIL mime@funduc.com for information on purchasing the source code.

Patch Creator

Patch Creator, one our legacy products, is a tool for software authors. It is a two part program used to make patches for updating registered versions software. Both the Patch Creator (used on the developer's end) and the Patch Applicator (applies the patch on the end user's machine) are easy to use GUI programs. Command line switches or complicated run instructions are not necessary on the user's end. The Creator and Applicator are 32 bit GUI Windows utilities. You can require passwords to run the Applicator (or not). Patches can be created to update files on users' machines from a specific version, add files regardless of existing version, remove files, or rename files. Patches that conduct 'updates' are based on binary differences between old vs. new files. Compression can be used to further reduce the size of the patch. Patches for multiple versions can be include in a single patch file. Patches can be configured to use a registry value on the end user's machine for setup path information and the applicator can also write a .reg file to the user's registry upon completion. In addition, patches can be set up to halt operations if specified files(s) are not found on the end user's machine. This can be used, for example, to not patch any files if a critical file you specify is not present. The Patch Creator has a script language for saving complex patch setups and it can be run from the command line for use in automated routines. A German version is also available.

Decode/Encode DLLs

Decode/Encode DLL is another legacy product for software developers. The Decode/Encode DLL can be called from any Windows programming language (such as VB, Visual C, Powerbuilder, etc.). It allows you to automatically detect if a given file is UUENCODED, Base64(MIME), XXENCODED, BinHex, encoded with a user-supplied table, quoted-printable, or plain text. The DLL can then decode the file(s) either in the current directory or in one specified by the user. Binary files can also be encoded for transmission over the Internet. Functions are available for encoding/decoding to/from memory buffers, listing message body text, and message headers. Utility functions for split/concatenate are also available. Example code and a model test program is included. Cost: $58 (no royalties).


About Search and Replace Wizard

SR Regular Expression Wizard

Copyright © 1999-2009 Funduc Software, Inc.
All Rights Reserved
www.funduc.com www.searchandreplace.com
support@funduc.com support@searchandreplace.com

See Ordering Information for details on how to purchase SR Regular Expression Wizard or write us at support@funduc.com. See License Information for details about licensing. For customer support, EMail us at support@funduc.com or visit our web site at www.funduc.com for FAQs & program updates. Also check our web site for product information, trialware & freeware downloads of our other award winning software products.


Add Button

Add: Add the highlighted item to the bottom of the Expression list.


Apply Button

Apply: Apply the changes to the highlighted item.


Cancel Button

Cancel: Exit Regular Expression Wizard and do not update the fields in Search and Replace.


Evaluator Finish

Finish: Close the wizard. If Search and Replace is running the search and replace strings will be inserted into the respective fields in Search and Replace.


Evaluator Next Hit

Next Hit: Jump forward to the next search hit (if any) in the sample text.


Evaluator Previous Hit

Previous Hit: Jump back to the previous search hit (if any) in the sample text.


Evaluator Replacement Sample

Replacement Sample: This is the replaced text based on the current Replace expression.


Evaluator Search Sample

Sample Text: This is the original sample based on the current Search expression.


Help Button

Help: Activates the program help.


Insert Button

Insert: Insert the current item one below the currently highlighted item in the Expression list.


MoveDown Button

Move Down: Move the highlighted item down by one in the Expression list.


MoveUp Button

Move Up: Move the highlighted item up by one in the Expression list.


No Sample Text Notice

Enter some sample text in the Sample Text area.

Alternatively, press CTRL+C or click on the "Paste" button to paste text from the Windows Clipboard OR use the "Load From File" button to import the contents of a specific file.


Old Info

Note: Some components of the Wizard F1 Help you are looking at here expect that you have Search and Replace installed and that both the Wizard & Search and Replace are installed in the same path (folder) on your computer. Also, some links in the Wizard F1 Help will take you to Search and Replace help topic sections. When this happens the top of your windows hlp screen is blue in color. Use the 'Back' button to return to 'Wizard' hlp.

If you do not have Search and Replace, a shareware copy can be obtained from our web site at www.funduc.com.

You may wish to view the help topic on Search and Replace Regular Expressions.


Remove Button

Remove: Remove the highlighted item from the Expression list.


RemoveAll Button

Remove All: Delete all the items from the Expression list.


Replacement Case Switch

Case Switch: Check or uncheck to change the case during a replace. This only affects a regular expression replacement operator.


Replace Expression Type

Expression Type: This list contains counterparts to the search expression operators and a choice to enter a specific string, 'String Listed Below'. If you use 'String Listed Below' a string in the "String" field.


Replace Expression List

Replacement Expression List: Initially listed here are the individual component operators of the "Replace Expression" from the Sample section of the Wizard. Click on each subexpression to see the controls associated with that subexpression - you can modify them (click on Apply to save your change). To add a new subexpression, use the Add or Insert button. Use the Move Up, Move Down, & Remove buttons to rearrange or delete subexpressions.


Replace Sample Text

Sample Text: The sample text you supplied in the Sample section of the Wizard is presented here. The display colors can be used to visualize the effect of each replacement operator on the first search hit. Blue identifies the operator currently highlighted in the "Expression" section of the dialog. Red identifies sections of the sample that are effected in some way by other operators in the "Expression" section. If the text is all dark, your search expression has not identified any hits.


Replacement String

String: Enter a literal string to use here. Input here is meant to be combined with the ''String Listed Below' choice in the Expression Type field. If your literal string involves any of the 'reserved characters', be sure to put a \ character in front of each to denote the literal.


Regular Expression Reserved Characters

'Reserved characters' are the regular expression wild card operators themselves. If you have a search or replace string that uses these as actual characters and not a regular expression operator you must make them literal by proceeding them with a \ character.

For search expressions the characters are: - + * ? ( ) [ ] \ | $ ^ !

For replace expressions the characters are: % \ < >

For example, to search for the \ character, you must use a double it - \\ - in order for \ to be matched correctly. If you want to use the < character in a replacement expression, enter \<.

Note: As you become experienced you may discover that % < > need not always be made literal in a replace expression. The critical rule is that if they are directly adjacent to a %n replacement operator they must be made literal with the \ character.

For more information see Search and Replace Regular Expressions.


Order Form

Search and Replace Regular Expression Wizard Fax and Mail Order Form

Funduc Software, Inc. - Fax and Mail Order Form

Search and Replace Regular Expression Wizard

Funduc Part Number: 188-SX-3733

Fax Orders:

Fax to the number indicated on the page at
www.funduc.com/contact.htm

Check Orders:

Funduc Software, Inc.
P.O. Box 530904
Livonia, MI 48153-0904
USA

-------- PRINT NEATLY OR TYPE! --------

Price Schedule | Price ($US) Per User | Number of Users | Price
Single user | $ 10.00 | _______ | $________
2 to 9 users | $ 9.00 | _______ | $________
10 to 24 users | $ 8.00 | _______ | $________
25 to 49 users | $ 7.00 | _______ | $________
50+ users | $ 5.00 | _______ | $________
Residents of Michigan, United States - add 6% sales tax |  |  | $________
Preferred Shipping Method Disk (USPS Domestic US) $8.00 S&H |  |  | $________
Disk (USPS International) $10.00 S&H |  |  | $________
Email (Free) |  |  | $___ 0 ___
TOTAL PAYMENT |  |  | $________

Credit Card Information
Card Type (Check One): | Visa[ ] American Express[ ] MasterCard[ ] Discover[ ]
Name as it appears on card: | ____________________________________________________
Credit Card Number: | ____________________________________________________
Expiration Date: | ____________________
Street Address: | ____________________________________________________
Street Address: | ____________________________________________________
City, State Zip: | ____________________________________________________
Country: | ____________________________
Your Information (Write 'Same' if not different from above)
Your Name: | ____________________________________________________
Company: | ____________________________________________________
Street Address: | ____________________________________________________
Street Address: | ____________________________________________________
City, State, Zip: | ____________________________________________________
Country: | ____________________________________________________
Day Phone Number: | ____________________________
Fax Number: | ____________________________
Alt Phone Number: | ____________________________
* EMail Address:* | ____________________________________________________
Signature: | ____________________________________________________
Date: | ____________________________

How did you find out about SR Regular Expression Wizard?

Comments:


Back Button

Back: This particular button does nothing.


Case Sensitive

Case Sensitive: Check/Uncheck this for case sensitive search or not.


Load File

Load File: Click here to use a standard Windows Open File dialog to select a file to use for a sample text.


Paste

Paste: Paste text from the Windows Clipboard into the Sample Text area.


Replace Expression

Replace Expression: When the Regular Expression Wizard first opens this field will contain the current search expression in the Search and Replace main dialog (if the program is running) or the last expressions in effect when the Wizard was used. The expression here will be the initial expression in the used Replace Expression section of the Wizard in the You may accept this expression or type/paste in another. Blank out the expression if you want to start from scratch. See Tips for more information.


Search Expression

Search Expression: When the Regular Expression Wizard first opens this field will contain the current search expression in the Search and Replace main dialog (if the program is running) or the last expressions in effect when the Wizard was used. The expression here will be the initial expression in the used Search Expression section of the Wizard. You may accept this or type/paste-in another. Blank out the expression if you want to start from scratch. See Tips for more information.


Sample Text

Sample Text: The sample text to use to help you visualize the effect of the search and replace expressions. You are required to enter something here. Alternatively, press CTRL+C or click on the "Paste" button to paste text from the Windows Clipboard OR use the "Load From File" button to import the contents of a specific file.


Search and Replace Regular Expressions

Additional technical information is available in the registered version of the Search and Replace Wizard.

Please see Purchase Information for information how to purchase the Search and Replace Wizard documentation. Thanks!


Search Characters

Or Characters List: This is a list of binary characters & standard alphanumeric characters you can use with one of the Expression Type choices. To select multiple characters, hold the shift key as you scroll or hold the ctrl key and select single items. When you press Insert or Apply, the selected items will be used.

Note: When Regular Expression mode is turned on in Search and Replace it is not necessary to use the binary mode dialogs. Binary codes can be inserted directly into the Search and Replace 'search' and 'replace' fields. The Regular Expression Wizard is always in 'regular expression' mode.


Search Expression Type

Search Expression Type: This combo box provides a list of the Wizard's build in operators. The choices are:

Exactly one occurrence: Select this to enter a literal string. Type the string itself in the "of String" field below. Note that if you enter and of the regular expression 'reserved characters' they will be converted to literals.

Zero or more occurrences: This is the Search and Replace * operator. If you want to establish a specific set of characters to enter in a () term, type them into the "of String" field. If you want to use [ ] and a range, highlight a range of characters in the 'of characters' list by holding down Shift as you select with the mouse or cursor keys. Click Apply or Insert to effect the entry.
NOTE: If you want to enter *[], select Zero or more occurrences, highlight all the characters in the 'of characters' list and click Apply or Insert.

One or more occurrences: This is the Search and Replace + operator. Usage is similar to the above.

A given range or occurrences: This is the Search and Replace 'Column Operator'. You can create a new entry using steps similar to the above or you can apply column operator to an existing entry by clicking on apply.

Beginning of Line: This is the Search and Replace ^ operator.

End of Line: This is the Search and Replace $ operator.

Start of file: This is the Search and Replace ^^ operator.

End of file: This is the Search and Replace $$ operator.

Expression below *not* matched: This is the Search and Replace 'not' operator - !. You will need to create a not expression in sections.

Expression below *is* matched: Use this to create ! operator terms that function as a type of 'and' operator.


Code

Code: This column lists the '%n values' for the regular expression operators. Regular expression wild card search operators are represented by %n operators (%1, %2, etc) in the counterpart replacement expression. The entries in the 'Code' column are there as an aid so you can visualize in the sample text know in advance what the %n number will for the operator in the replacement expression. The %n operators are selected via 'Match of search expression #1, Match of search expression #2, etc' in the 'Expression Type' field of the Replace Expression window.


Search Expression List

Search Expression List: The individual component subexpressions (operators) of the "Search Expression" from the Sample section of the Wizard are listed here. Click on each subexpression to see the controls associated with that subexpression - you can modify them (click on Apply to save your change). To add a new subexpression, use the Add or Insert button. Use the Move Up, Move Down, & Remove buttons to rearrange or delete subexpressions.


Search Occurrences

Search Occurrences: Entered here in the ''At least' and '... but no more than' fields are the number of columns to match. This area is only available for input when 'A given range or occurrences' is selected in the Expression Type field. See 'Column Operator' for more information.


Search Sample Text

Sample Text: The sample text you supplied in the Sample section of the Wizard is presented here. The display colors can be used to visualize the effect of each operator on the first search hit. Blue identifies the operator currently highlighted in the "Expression" section of the dialog. Red identifies sections of the sample that are effected in some way by other operators in the "Expression" section. If the text is all dark, your search expression has not identified any hits.

Note that the coloring is only available for the first overall search hit. Only one search hit is possible in the sample text here. If two (or more) were possible, coloring would be applied to the first hit only. You have an opportunity in the Evaluation section of the Wizard to examine each hit individually.


Search String

Of String Field: Enter a literal string to use here. If you want to use a specific string, select 'Exactly one occurrence' in the Expression Type field. You can combine a string here with one of the other operators in the "Expression Type" field, e.g, *, +, . Note: Regular expression reserved characters will be made into literals with a \ character.